﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
Sub Process_Globals
	Private M_3, MHue_3 As lgMathMatrix3
	Private Const lumR As Float = 0.213
	Private Const lumG As Float = 0.715
	Private Const lumB As Float = 0.072
	Private MU As lgMathUtils
End Sub

'Hue: from 0 to 360. 0 or 360 = no change.
'Saturation: 0 = gray-scale, 1 = no change.
Sub ChangeHueSaturation(Hue As Int, Saturation As Float) As lgMathMatrix3
	'Computes and returns the color matrix
	If Saturation <> 1 Then
		Dim invSat As Float = 1 - Saturation
		Dim R As Float = lumR * invSat
		Dim G As Float = lumG * invSat
		Dim B As Float = lumB * invSat
		M_3.val(M_3.M00) = R + Saturation
		M_3.val(M_3.M01) = G
		M_3.val(M_3.M02) = B
		M_3.val(M_3.M10) = R
		M_3.val(M_3.M11) = G + Saturation
		M_3.val(M_3.M12) = B
		M_3.val(M_3.M20) = R
		M_3.val(M_3.M21) = G
		M_3.val(M_3.M22) = B + Saturation
	Else
		M_3.idt
	End If
	If Hue > 0 AND Hue < 360 Then
		Dim NewHue As Float = Hue / 180 * cPI
		Dim cosVal As Float = MU.Cos(NewHue)
		Dim sinVal As Float = MU.Sin(NewHue)
		MHue_3.val(M_3.M00) = lumR + cosVal * (1 - lumR) + sinVal * (-lumR)
		MHue_3.val(M_3.M01) = lumG + cosVal * (-lumG) + sinVal * (-lumG)
		MHue_3.val(M_3.M02) = lumB + cosVal * (-lumB) + sinVal * (1 - lumB)
		MHue_3.val(M_3.M10) = lumR + cosVal * (-lumR) + sinVal * (0.143)
		MHue_3.val(M_3.M11) = lumG + cosVal * (1 - lumG) + sinVal * (0.140)
		MHue_3.val(M_3.M12) = lumB + cosVal * (-lumB) + sinVal * (-0.283)
		MHue_3.val(M_3.M20) = lumR + cosVal * (-lumR) + sinVal * (lumR - 1)
		MHue_3.val(M_3.M21) = lumG + cosVal * (-lumG) + sinVal * (lumG)
		MHue_3.val(M_3.M22) = lumB + cosVal * (1 - lumB) + sinVal * (lumB)
		M_3.mul(MHue_3)
	End If
	Return M_3
End Sub
